
mainMenu = {}

function mainMenu:init()
    self.current = "menu"
    self.oldCurrent = nil
    
    self.menu = gooi.newPanel({
        w=W()/2, h=H()*.5,
        x=W()-((W()/2)/2)-W()/2,  y=0+(H()*.55)/2,
        group="menu",
        layout="grid 2x2"
    }):
    setColspan(1,1,2):
    add(
        gooi.newButton({text="Play",group="menu"}):
            onRelease(function(b)
                self.current = "load"

            end
            ),
        gooi.newButton({text="Help",group="menu"}):
            onRelease(function()
                game:startNewGame()--self.current = "help"
            end
            ),
        gooi.newButton({text="Exit",group="menu"}):
            onRelease(function()
                game:quit()
            end
            )
        
    )
        
    self.load = gooi.newPanel({
        w=W()/2, h=H()*.45,
        x=W()-((W()/2)/2)-W()/2, y=0+(H()*.55)/2,
        group="load",
        layout="grid 2x2"
    }):
    setColspan(1,1,2):
    add(
        gooi.newButton({text="Local Wifi",group="load"}):
            onRelease(function(b)
                self.current = "locall"
            end
            ),
        gooi.newButton({text="Online",group="load"}):
            onRelease(function()
            end
            ),
        gooi.newButton({text="Back",group="load"}):
            onRelease(function()
                self.current = "menu"
            end
            )
        )
        
    self.locall = gooi.newPanel({
        w=W()/2, h=H()*.45,
        x=W()-((W()/2)/2)-W()/2, y=0+(H()*.55)/2,
        group="locall",
        layout="grid 2x2"
    }):
    setColspan(2,1,2):
    add(
        gooi.newButton({text="Join",group="locall"}):
            onRelease(function(b)
                game:waitForHost()
            end
            ),
        gooi.newButton({text="Host",group="locall"}):
            onRelease(function()
                self.current = "host"
            end
            ),
        gooi.newButton({text="Back",group="locall"}):
            onRelease(function()
                self.current = "load"
            end
            )
        )
        
    
    self.waiting = gooi.newPanel({
        w=W()/4, h=H()-10,
        x=10, y=0,
        group="wait",
        layout="grid "..(MAX_PLAYERS+2).."x1"
    }):add(
        gooi.newButton({text="START",group="wait"}):
            onRelease(function()
                if game.host then
                    self.peer:sendToAll("startMatch","deathmatch")
                    self.peer:update(0)
                    game:startNewGame()
                else
              --      gooi.alert({text="Only the host can start the game!",group="wait"})
                end
            end)
    )
    self.wait = self.waiting
    self.waitButtons = {}
    for x = 1, MAX_PLAYERS do
        self.waitButtons[x] = gooi.newButton({group="wait",text="..."})
        self.waiting:add(self.waitButtons[x])
    end
    self.waiting:add(
        gooi.newButton({text="Back",group="wait"}):
            onRelease(function()
                if game.host then
                    game.host:destroy()
                end
                self.current = "locall"
            end)
    )
    
    
    self.host = gooi.newPanel({
        w=W()/2, h=H()*.65,
        x=W()-((W()/2)/2)-W()/2, y=0+(H()*.55)/2,
        group="host",
        layout="grid 6x1"
    }):
    add(
        gooi.newButton({text="Host",group="host"}):
            onRelease(function()
                self.current = "wait"
                game:waitForPlayers()--startNewGame()
            end),
        gooi.newLabel({text="Game Type",group="host"}):left(),
        gooi.newRadio({text="death match",radioGroup="d",group="host"}),
        gooi.newRadio({text="team death match",radioGroup="d",group="host"}),
        
        gooi.newRadio({text="king pin",radioGroup="d",group="host"}),
      --  gooi.newRadio({text="expert",radioGrop="d",group="host"}),

        gooi.newButton({text="Back",group="host"}):
            onRelease(function()
                self.current = "locall"
            end
            )
        
    )
    
    self.help = HelpMenu:new({group="help"})
    self._current = self.menu
        
    self.menus = {
        load = self.load,
        menu = self.menu,
        locall = self.locall,
        host = self.host,
        join = self.join,
        wait = self.waiting,
        help = self.help
    }
end

function mainMenu:update(dt)
    local trash = self._current.update and self._current:update(dt) or gooi.update(dt)
   
    if self.peer and not self.peer.pause then
        self.peer:update(dt)
    end

    if self.oldCurrent ~= self.current then
    if self.current=="new" then ggr=4 end
        for i,n in lume.iter(self.menus) do
            local trash = n.destroy and n:destroy()
            gooi.removeComponent(n)--self.menus[self.current])
        end
        gooi.pressed() gooi.released()
        local m = self.menus[self.current]
        self._current = self.menus[self.current]
        local trash = m.create and m:create()
        gooi.currentGroup = self._current.group
        gooi.addComponent(m.__class and m.info or m)
        self.oldCurrent = self.current
    end
    self._current = self.menus[self.current]
       
end


function mainMenu:enter()
    self:init()
end

function mainMenu:resume()
    self:init()
end

function mainMenu:destroy()
    gooi.removeComponent(self._current)
    gooi.currentGroup = nil
end

function mainMenu:draw()

    local trash = self._current.draw and self._current:draw() or
        gooi.draw(self.current)
--    gooi.draw()
end

function mainMenu:leave()
    for i,n in lume.iter(self.menus) do
        local trash = n.destroy and n:destroy()
        gooi.removeComponent(n)--self.menus[self.current])
    end
end

function mainMenu:mousereleased() gooi.released() log("released") end
function mainMenu:mousepressed()  gooi.pressed() log("pressed") end

function mainMenu:touchreleased(id, x, y, dx, dy, pressure)
    if not self.buttonPressed then
        ttx = x
        tty = y
    end
    self.buttonPressed = false
    local trash = self._current.touchreleased and 
        self._current:touchreleased(id,x,y,dx,dy,pressure)
end

function mainMenu:touchpressed(id, x, y, dx, dy, pressure)

    local trash = self._current.touchpressed and 
        self._current:touchpressed(id,x,y,dx,dy,pressure)
    end
function mainMenu:textinput(text)
  gooi.textinput(text)
end

function mainMenu:keypressed(key, scancode, isrepeat)
  gooi.keypressed(key, scancode, isrepeat)
  if key == "escape" then
    p:close()
    love.event.quit()
  end
end

function mainMenu:keyreleased(key, scancode) log(key) log("kr")
  gooi.keyreleased(key, scancode)
end

return mainMenu