--A wrapper for splashy

 Splash = class:extend("Splash")
 
 function Splash:__init__()
    --self.splashy = splashy (not needed)
    self.camera = Camera()
end

function Splash:update(dt)
    self.camera:update(dt)
    splashy.update(dt)
end

function Splash:draw()
    self.camera:attach()
    splashy.draw()
    self.camera:detach()
   -- self.camera:draw()
end

function Splash:addSplash(...)
    local args = {...}
    log(ser(args[2] or 2))
    self.camera:fade((args[2] or 2)/2,{0,0,0,1})
    splashy.addSplash(...)
end

function Splash:onComplete(func)
    splashy.onComplete(function()
        self.camera:fade(1,{0,0,0,0})
        func()
    end)
end

return Splash