
function circleCollision(cx, cy, r, sx, sy, sh, sw)
    if type(sx) == "table" then
        local obj = sx
        sx = obj._x or obj.x
        sy = obj._y or obj.y
        sh = obi.h
        sw = obj.w
    end
    
    local testX, testY = cx, cy
    
    if cx<sx then
        testX = sx
    elseif cx>sx+sw then
        testX = sx+sw
    end
    if cy<sy then
        testY = sy
    elseif cx>sy+sh then
        testX = sy+sh
    end
    
    local dist = lume.distance(cx, cy, testX, testY)
    
    if dist<=r then
       return true
    end
    
    return false
end