Menu = class:extend("SelectMenu")

local done
function Menu:__init__(kwargs)

    done = {}
    kwargs = {}
    
    self.listbox = lume.copy(listbox)

    
    
    self.listbox:init()

    
    self.data = kwargs.data or {}
    self.group = kwargs.group
    
    self.title = gooi.newLabel({text="chose level", w = W(), h = H()/8})
    self.button = gooi.newButton({text="start", w = W(), h = H()/8,y=H()-(H()/7)}):
        onRelease(function()
            self:start()
        end)


    self._data = {
        x = kwargs.x or 0,
        y = (H()/8),
        w = W(),
        h = kwargs.h or (H()/8)*6,
        istouch = true,
        visible = true,
        incenter = false,
        enabled = true,
        selectedcolor = game:getColor("green"),
        fsize = 50,
        asize = false,--fit box to sizee
        --expand=true,expmode="size",
    }
    
    
    self.listbox:newprop(self._data)
    
    self.add=function(...) self.listbox:additem(...) end
    self:loadOptions()


    
end

function Menu:loadOptions(path, name)
    for name, storage in pairs(data.levels) do
        if not done[storage] then
            self.listbox:additem(storage.name or name)
            done[storage] = true
        end
    end
end

function Menu:start()
    self:destroy()
    local title = self:getSelectedText()
    game:startNewGame(nil,title)
end

function Menu:draw()
    self.listbox:draw()
    gooi.draw()
end

function Menu:destroy()
    self.listbox:setenabled(false)
    self.listbox:setvisible(false)
    gooi.removeComponent(self.title)
    gooi.removeComponent(self.button)
end

function Menu:create()
    gooi.removeComponent(self.title)
    gooi.removeComponent(self.button)
    self.listbox:setenabled(true)
    self.listbox:setvisible(true)
    gooi.addComponent(self.button)
    gooi.addComponent(self.title)
end

function Menu:getSelectedText()
    return self.listbox:gettext(self.listbox:getselected())
end

function Menu:getSelectedData()
    return self.listbox:getdata(self.listbox:getselected())
end


function Menu:update(dt)
    self.listbox:update(dt)
    local t = self:getSelectedData()
    if t ~= self.oldSelected then
        self.oldSelected = t
        --self.info:setText(t)
    end
    --gooi.update(dt)
end

function Menu:mousepressed(x,y,button)
    gooi.pressed()
end

function Menu:mousereleased(x,y,button)
    gooi.released()
end

function Menu:touchpressed(id, x, y, dx, dy, pressure)
    self.listbox:press(x,y)
end

function Menu:touchreleased(id, x, y, dx, dy, pressure)
    self.listbox:released(x,y)
end

return Menu
    