local World = require("tools/GOAPlua/World")
local Planner = require("tools/GOAPlua/Planner")
local Action = require("tools/GOAPlua/Action")

local world = Planner.new('hungry', 'has_food', 'in_kitchen', 'tired', 'in_bed',
'in_shop', 'has_ingredients', 'has_money')

world:set_start_state({hungry=true, has_food=false, in_kitchen=false, tired=true, in_bed=false,
in_shop=false, has_ingredients=false, has_money=false})

--world:set_goal_state({tired=false})
world:set_goal_state({tired=false,has_food=true})


local actions = Action.new()
act = function(...) actions:add_condition(...) end
rea = function(...) actions:add_reaction(...) end
actions:add_condition('eat', {hungry=true, has_food=true, in_kitchen=false})

--actions:add_reaction('eat', {hungry=false})
actions:add_reaction('eat', {hungry=false,has_food=false})

actions:add_condition('cook', {hungry=true, has_food=false, in_kitchen=true, has_ingredients=true})
actions:add_reaction('cook', {has_food=true})

actions:add_condition('go_to_shop', {in_shop=false,has_ingredients=false})
rea("go_to_shop",{in_shop=true})

act("buy_stuff", {has_money=true,in_shop=true})
rea('buy_stuff',{has_ingredients=true,has_money=false})

act('beg_for_money',{hungry=true,in_shop=true})
rea('beg_for_money',{has_money=true})

actions:add_condition('sleep', {tired=true, in_bed=true})
actions:add_reaction('sleep', {tired=false})

actions:add_condition('go_to_bed', {in_bed=false, hungry=false})
actions:add_reaction('go_to_bed', {in_bed=true})

actions:add_condition('go_to_kitchen', {in_bed=false,in_kitchen=false})
actions:add_reaction('go_to_kitchen', {in_kitchen=true})

actions:add_condition('leave_kitchen', {in_kitchen=true})
actions:add_reaction('leave_kitchen', {in_kitchen=false})

actions:add_condition('order_pizza', {has_food=false, hungry=true, has_money=true})
actions:add_reaction('order_pizza', {has_food=true})

actions:add_condition("sleep_up",{in_bed=true})
actions:add_reaction("sleep_up",{in_bed=false,hungry=true})

actions:set_weight('go_to_kitchen', 2)
actions:set_weight('order_pizza', 20)

world:set_action_list(actions)

local t = os.clock()
local path = world:calculate()
local took_time = os.clock() - t 

for k,_p in pairs(path) do 
    log(k.._p['name'])
end 

log ('Took:'.. took_time)