math.randomseed(love.timer.getTime())
math.randomseed(10)--????

_g = {}
for u,i in pairs(_G) do _g[u] = i end

function love.load()
    --potrait
    love.window.setMode(1,2)
    
    
    RECORDS = {
        updateCount = 0
    }
    getUpdateCount = function()
        return RECORDS.updateCount
    end
    
    loadLuaCode = _G.load or _G.loadstring
    loadString = loadLuaCode
    
    --class
    class = require 'tools/class'


    --home brewed helper functions
    require 'tools/tools'



    --home brewed helper classes
    Animation = require 'tools/animation'
    Scheduler = require 'tools/scheduler'
    Joystick = require 'tools/joystick'


    --stuffses
    require 'tools/gooi'
    require "tools/goap"
    



    --helper functions/variables
    color = require 'tools/color'
    mlib = require 'tools/mlib'
    sti = require "tools/sti"
    rot = require "tools/src.rot"
    lume = require 'tools/lume'
    colors = color
    bump = require 'tools/bump'
    inspect = require 'tools/inspect'
    json = require 'tools/json'
    animx = require 'tools/animx'



    
    
    --helper classes
    listbox = require 'tools/listbox'
    Paddy = require 'tools/paddy'
    JumperGrid = require "tools/jumper.grid"
    PathFinder = require "tools/jumper.pathfinder"
    Gamestate = require "tools/hump/gamestate"
    Signal = require "tools/hump/signal"
    Timer = require "tools/hump/timer"
    saveTable = require "tools/saveTable"
    splashy = require "tools/splashy"
    Graph = require "tools/graph"
    Andralog = require "tools/andralog"
    multisource = require "tools/multisource"
    Talkies = require "tools/talkies"
    windfield = require "tools/windfield"
    wf = windfield
    
    --ai tools
    Planner = require "tools/Goaplua/Planner"
    Action = require "tools/Goaplua/Action"


    --core stuff
    Game = require "game"
    Splash = require "splash"
    media = require "media"
    DialogScreen = require "dialogScreen"
    
    --menus
    infoMenu = require "menus/infoMenu"
    HelpMenu = require "menus/helpMenu"
    mainMenu = require "menus/mainMenu"
    
    SelectMenu = require "menus/selectMenu"
    SelectGameMenu = require "menus/selectGameMenu"
    SelectGameLevel = require "menus/selectGameLevel"
    
    PhysicalStatsViewer = require "menus/physicalStatsViewer"
    PSV = PhysicalStatsViewer
    EmotionalStatsViewer = require "menus/emotionalStatsViewer"
    ESV = EmotionalStatsViewer

    
    game = Game:new()
    game:__init__()
    media.load()
    --data
    data = require "data"
    
    store = function(...) return game:store(...) end


    
    ProFi = require "tools/ProFi"


    Camera = require 'tools/camera'

    ---
    
    randomchoice = lume.randomchoice
    utils = lume

    DT = 0
    DTmax = .5

    ---Shortcuts for often used functions, variables, etc...---
    Gs = Gamestate
    GS = Gamestate
    GSwitch = Gamestate.switch
    Gss = Gamestate.switch
    GSS = Gamestate.switch
    
    
    ---For switching back to the old state (can also use actual index in class: .oldState)---
    OLD_STATE = nil


    Gamestate.registerEvents()
    game:start()
    
end
